.include "cpctelera.h.s"
.include "sys_collisions.h.s"
.include "../managers/man_entity.h.s"
.include "sys_render.h.s"
.include "../maps/map_tiles/tiles.h.s"
.include "../maps/lvl0/lvl0.h.s"
.include "../managers/man_game.h.s"
.include "../generic_operations.h.s"
.include "../managers/man_maps.h.s"
.include "../sfx.h.s"

pos_tile: .dw #0000             ;; variable que almacena las posiciones en tiles en X Y


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: detecta colisiones y mueve uno al lado contrario de la colision
;;NECESITA: IX (direccion al jugador)
;;MODIFICA: A, B
;;RETURNS: A (1 WIN, 0 STAY)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_collisions_win:
    ld ix, #player

    ld a, e_vx(ix)
    dec a
    jr nz, no_win           ;compruebo si me muevo a la derecha
        ld a, #right_border
        ld b , e_w(ix)
        sub b               ;borde-ancho_sprite= borde para posicion inical del player
        sub e_x(ix); 
        jr nc, no_win       ;comprueba si estoy en el borde

            ;; como me he pasado el mapa aqui aumento el contador para cargar el siguiente mapa

            ld a, (contador_mapas)      ;; cargamos el contador de mapas
            inc a
            ld (contador_mapas), a
 
            ld de, #total_map_size
            ld iy, (#map_data)
            add iy, de
            
            ld l, 4(iy) 
            ld h, 5(iy)
            ld (compressed_maps), hl

            call man_entity_map_data

            ld a, #1          ;A a 0 para cambiar de estado y return
            ret
    no_win:
    xor a
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: pasa por todas la entidades comprobando y actuando en consecuencia a las colisones con el juegador
;;NECESITA:
;;MODIFICA: A, BC, DE, IY, IX
;;RETURNS: A (1 LOSE, 0 STAY)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
calc_colisiones_entity:
    

    ld ix, #player
    ld iy, #player

    ld a, (#entity_num) 
    ld b, a
    update_next:
        ld de, #entity_size
        add iy, de 

        ld d, e_nk_r(iy)
        ld a, d
        cp #0
        jr z, jump
        push bc
            call collision_player_enemy
            dec a
            jr z, no_colision

                ld a, d
                sub #8
                jr nz, no_llave
                    call llaveVoladora_Desaparece
                    ld a, #1
                    call play_sound
                    xor a
                    pop bc
                    ret
                no_llave:
                ld a, #1
                pop bc
                ret
            no_colision:
        pop bc
        jump:
    djnz update_next

    xor a
ret	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: detecta colisiones con el enemigo
;;NECESITA: IX (direccion al jugador) IY (DIRECCION A ENEMIGO)
;;MODIFICA: A, BC
;;RETURNS: A (1 LOSE, 0 STAY)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;se puede optimizar en tiempo añadiendo el punto abajo derecha a las variables de entidad, y actualizandolo en man_entity_update-*-*-*-*-*-*-*-*-*-*-*-*-**-*-*-*-*-
collision_player_enemy:

        ;; Comprobacion colision Izquierda
        ld a, e_x(iy)           ;; Cargamos en A la posicion del enemigo
        ld c, e_w(iy)           ;; Cargamos en C el ancho del enemigo
        add c   
        ld b, e_x(ix)           ;; Le sumamos el ancho a la posicion para obtener 
        sub b                   ;; le restamos a lo anterior la posicion X del jugador
        jr z, fin_no_col        ;; si ninguna de estas comprobaciones se cumple puede ser que este colisionando, asi que continuamos 
        jp m, fin_no_col        

        ;; Comprobacion colision Derecha

        ld a, e_x(ix)           ;; Cargamos en A la posicion del jugador
        ld c, e_w(ix)           ;; Cargamos en C el ancho del jugador
        add c   
        ld b, e_x(iy)           ;; Le sumamos el ancho a la posicion para obtener 
        sub b                   ;; le restamos a lo anterior la posicion X del jugador
        jr z, fin_no_col
        jp m, fin_no_col

        ;; Comprobacion colision Arriba

        ld a, e_y(ix)
        ld c, e_h(ix)
        add c
        ld b, e_y(iy)
        sub b
        jr z, fin_no_col
        jp m, fin_no_col

        ;; Comprobacion colision Abajo
       
        ld a, e_y(iy)
        ld c, e_h(iy)
        add c
        ld b, e_y(ix)
        sub b
        jr z, fin_no_col
        jp m, fin_no_col
        jr fin_col

    fin_no_col:
    ld a, #1
    jr finaltotal

    fin_col:
    ld a, #0

    finaltotal:

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: maneja las colisiones el player con el tilemap
;;NECESITA:-
;;MODIFICA: A, BC
;;RETURNS: A (1 LOSE, 0 STAY)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_collisions:
    ld ix, #player
    
    ld d , e_mid_x(ix)                     ;; cargamos en del carry de x
    dec d
    inc d                           ;; lo decrementamos para saber si es 0 o no
    jr	nz, end_x                    ;; si es 0 saltamos el codigo de X


    ld d, e_mid_y(ix)                      ;; cargo en d el carry del eje Y
    dec d
    inc d                        ;; lo decremento para activar el flag z
    jr nz, vx_zero                ;; si esto es cero cambio la velocidad del eje x a 0

    ld a, e_vx(ix)                         ;;selecciono a de movimiento en x
    dec a
    inc a
    jr z, end_x
    jp m, no_right
        ;;;;; DERECHAAAAAAA ;;;;;
        ld a, #0x00
        call final_col
        jr end_x                                ;;aqui es innecesario por que hay ret pero si nos movemos a la derecha no podemos movernos a la izquierdo

    no_right:
        ;;;;; IZQUIERDAAAAAAA ;;;;;
        ld a, #0x02
        call final_col
        jr end_x

    vx_zero:
        xor a                                       ;; A a 0 para cambiar de estado y return
        ld e_vx(ix), a                              ;; ponemos la velocidad a 0
    end_x:

    ;;comprobamos eje y

    ld d, e_mid_y(ix)                     ;; cargamos en d el primero de los carrys
    dec d    
    inc d                        ;; lo decrementamos para saber si es 0 o no
    jr	nz, end_y                     ;; si es 0 saltamos el codigo de Y

    ld d, e_mid_x(ix)                      ;; cargo en d el carry de el eje X
    dec d 
    inc d                        ;; lo decremento para activar el flag z
    jr nz, vy_zero                ;; si esto es cero cambio la velocidad del eje x a 0

    ld a, e_vy(ix)                  ;;seleciono a de movimiento en x
    dec a
    inc a
    jr z, end_y
    jp m, no_down

    ;;;;; ABAJOOOOOOOOOOOO ;;;;;
        ld a, #0x01
        call final_col
        jr end_y

    no_down:
    ;;;;; ARRIBAAAAAAAAAA ;;;;;
        ld a, #0x03
        call final_col
        jr end_y

    vy_zero:
        xor a                                       ;; A a 0 para cambiar de estado y return
        ld e_vy(ix), a                              ;; ponemos la velocidad a 0
    end_y:

    ;;COMPROBACION DE VELOCIDAD DOBLE (EJE X != 0 Y EJE Y != 0);;

    ld d, e_vx(ix)                              ;; cargamos la velocidad x en d
    ld e, e_vy(ix)                              ;; cargamos la velocidad y en e
    
    dec d                                       
    inc d
    jr z, final                                 ;; compruebo si la velocidad en el eje X es diferente de 0

    dec e
    inc e
    jr z, final                                 ;; compruebo si la velocidad en el eje Y es diferente de 0 

    ld h, e_prev_vx(ix)                           ;; CORRECION ESQUINAS PARADO cargamos en HL el mov de la ejecucion pasada
    dec h                                       
    inc h
    jr nz, continuacion                                 ;; compruebo si la velocidad en el eje X es diferente de 0

    ld l, e_prev_vy(ix) 
    dec l
    inc l
    jr nz, continuacion                                 ;; compruebo si la velocidad en el eje Y es diferente de 0 

    xor a 
    ld e_vx(ix), a  

    continuacion:

    ld h, e_prev_vx(ix)
    ld l, e_prev_vy(ix)                           ;; si no lo es, cargamos en HL la velocidad que tuvo el pj en la ejecucion anterior

    xor a                                       ;; ponemos A a 0

    dec h
    dec h
    inc h
    jr nz, continuar                            ;; comprobamos si el valor en el eje X FUE +1, si no lo fue saltamos 

    ld e_vx(ix), a                              ;; si lo fue ponemos el valor de velocidad X a 0

    continuar:
    inc h
    inc h 
    jr nz, continuar2                           ;; comprobamos si el valor en el eje X FUE -1

    ld e_vx(ix), a                              ;; si lo fue ponemos el valor de velocidad X a 0, si no lo fue saltamos 

    continuar2: 

    dec l
    dec l
    jr nz, continuar3                           ;; comprobamos si el valor en el eje Y FUE +2, si no lo fue saltamos 

    ld e_vy(ix), a                              ;; si lo fue ponemos el valor de velocidad Y a 0

    continuar3:                                 ; comprobamos si el valor en el eje Y FUE -2, si no lo fue saltamos 
    inc l
    inc l
    inc l
    inc l
    jr nz, final
    
    ld e_vy(ix), a                              ;; si lo fue ponemos el valor de velocidad Y a 0

    

    final:
    
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: calcula el puntero a bloques de memoria adyacente
;;NECESITA:     DE (lado a comprobar)
;;MODIFICA:     HL, BC, A
;;RETURNS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
final_col:

        call get_adyacent_tile
        ;comprobamos el valor del tile


        ;;; ESTO COMPRUEBA QUE EL TILE ES UN BLOQUE DE PARED ;;;


        ld d, a   ;;D direccion (clock notation)
        ld a, (hl)

        cp #32          ;; numero a partir del cual los tiles son colisionables

        jr c, fin3

            ld a, d

            ;;comprobamos si cambiamos la velociadd de x o de y
            inc c
            jr nz, no_x
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vx(ix), a                      ;; ponemos la velocidad a 0
                jr fin4
            no_x:
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vy(ix), a                      ;; ponemos la velocidad a 0
        fin3:

        ;;; ESTO COMPRUEBA QUE EL TILE ES UN BLOQUE DE LLAVE ;;;

        call comprobar_llave_player

        ;;; ESTO COMPRUEBA QUE EL TILE ES UN BLOQUE DE PUERTA ;;;

        call comprobar_puerta_player

        ;;; ESTO COMPRUEBA QUE EL TILE ES UN BLOQUE DE ANILLO ;;;

        call comprobar_anillo_player

        fin4:

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: calcula el puntero a bloques de memoria adyacente
;;NECESITA:     A (lado a comprobar) 00 derecha 01 abajo 02 left 03 up IX(entidad)
;;MODIFICA:     HL, BC
;;RETURNS:      HL pointer to adyacent tile, C as way of knowing x block or y block for player colisions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_adyacent_tile:
    ;; calculamos el puntero al tile que nos queremos mover
    ld h, e_tp_h(ix)
    ld l, e_tp_l(ix)
    ld c, #-1;; ESTO NO SOBRA, es para poder generar B como un return util
    ;resto tres con el objetivo de dejar los numero a negativo, y voy incrementando 1 a cada comprobacion solo uno valdra 0 y es que hay que devolver

    sub a, #3    
    jr nz , no_up_

        ;;up-------------
        ld b, #0xFF
        ld c, #- _lvl0_W
        add hl, bc  

        add a, #3

        jr final2

    no_up_:
    inc a
    jr nz, no_left_

        ;;left------------
        dec hl

        add a, #2
        jr final2

    no_left_:
    inc a
    jr nz, no_down_

        ;;down------------
        ld b, #0
        ld c, #_lvl0_W
        add hl, bc

        add a, #1

        jr final2

    no_down_:
        inc a
        ;;right----------
        inc hl                               ;;cojo el siguiente tile

    final2:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: calcula x e y en bytes del tile a pintar
;;NECESITA:     A (lado a comprobar) 00 derecha 01 abajo 02 left 03 up IX(entidad)
;;MODIFICA:     BC, A -> jurao
;;RETURNS:      C -> x en bytes  B -> y en bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

get_adyacent_tile_bytes:

    sub a, #3    
    jr nz , no_up_2

        ;;up-------------
        ld c, e_x(ix)
        ld a, e_y(ix)

        ld b, #8
        sub b
        ld b, a

        add a, #3

        jr final3

    no_up_2:
    inc a
    jr nz, no_left_2

        ;;left------------
        ld a, e_x(ix)
        ld b, e_y(ix)

        ld c, #4
        sub c
        ld c, a

        add a, #2
        jr final3

    no_left_2:
    inc a
    jr nz, no_down_2

        ;;down------------
        ld c, e_x(ix)
        ld a, e_y(ix)

        ld b, #8
        add b
        ld b, a

        add a, #1

        jr final3

    no_down_2:
        inc a
        ;;right----------
        ld a, e_x(ix)
        ld b, e_y(ix)

        ld c, #4
        add c
        ld c, a

    final3:

ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: cambia el tile que le pases a tile de suelo
;;NECESITA:   
;;MODIFICA: 
;;RETURNS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pintar_suelo:

        ld (hl), #00            ;; esto hace que donde habia una llave ponga como si fuera suelo para no poder volver a coger la misma llave

        ld de, #0xC000
        call get_adyacent_tile_bytes

        call cpct_getScreenPtr_asm
        ex de, hl

        ld hl, #tile_floor
        call cpct_drawTileAligned4x8_asm

ret	



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: comprueba la llave que esta cogiendo el player
;;NECESITA: 
;;MODIFICA: 
;;RETURNS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
comprobar_llave_player::


    cp #2                       ;; compruebo que la llave es amarilla
    jr nz, no_y_key2

        ld a, d                 ;; A, D direccion (clock)

        call pintar_suelo

        ld a, e_nk_y(ix)          ;; cargo en a mi numero de llaves actual
        inc a                   ;; incremento a en 1 porque he pasado por una llave y la he cogido
        ld e_nk_y(ix), a          ;; cargo en mis llaves el nuevo numero

        push af
        ld a, #1
        call play_sound
        pop af

        jr no_key2

    no_y_key2:


    cp #5                       ;; compruebo que la llave es roja
    jr nz, no_r_key2


        ld a, d

        call pintar_suelo

        ld a, e_nk_r(ix)          ;; cargo en a mi numero de llaves actual
        inc a                   ;; incremento a en 1 porque he pasado por una llave y la he cogido
        ld e_nk_r(ix), a          ;; cargo en mis llaves el nuevo numero

        push af
        ld a, #1
        call play_sound
        pop af

        jr no_key2

    no_r_key2:


    cp #8                       ;; compruebo que la llave es azul
    jr nz, no_b_key2


        ld a, d

        call pintar_suelo

        ld a, e_nk_b(ix)          ;; cargo en a mi numero de llaves actual
        inc a                   ;; incremento a en 1 porque he pasado por una llave y la he cogido
        ld e_nk_b(ix), a          ;; cargo en mis llaves el nuevo numero
        
        push af
        ld a, #1
        call play_sound
        pop af

        jr no_key2

    no_b_key2:


    cp #11                      ;; compruebo que la llave es verde
    jr nz, no_g_key2

        ld a, d

        call pintar_suelo

        ld a, e_nk_g(ix)          ;; cargo en a mi numero de llaves actual
        inc a                   ;; incremento a en 1 porque he pasado por una llave y la he cogido
        ld e_nk_g(ix), a          ;; cargo en mis llaves el nuevo numero

        push af
        ld a, #1
        call play_sound
        pop af

        jr no_key2

    no_g_key2:

    no_key2:



ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;DESCRIPCION: comprueba si el player tiene las llaves neccesarias para abrir la puerta
;;NECESITA: A,  D, C
;;MODIFICA: 
;;RETURNS: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


comprobar_puerta_player:


        cp #3               ;;compruebo que la puerta es amarilla
        
        jr nz, no_y_door

            ld a, e_nk_y(ix)


            ld iy, (#map_data)
            ld l, 3(iy) 
            sub l

            jr nz, no_pasar_y

                ld a, d
                call pintar_suelo

                    push af
                    ld a, #2
                    call play_sound
                    pop af

                jp no_door

            no_pasar_y:

            inc c
            jr nz, no_x2
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vx(ix), a                      ;; ponemos la velocidad a 0
                jr no_y_door
            no_x2:
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vy(ix), a                      ;; ponemos la velocidad a 0

        no_y_door:


        cp #6               ;;compruebo que la puerta es roja
        
        jr nz, no_r_door

            ld a, e_nk_r(ix)
            cp #1

            jr nz, no_pasar_r

                ld a, d
                call pintar_suelo

                    push af
                    ld a, #2
                    call play_sound
                    pop af

                jp no_door

            no_pasar_r:

            inc c
            jr nz, no_x3
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vx(ix), a                      ;; ponemos la velocidad a 0
                jr no_r_door
            no_x3:
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vy(ix), a                      ;; ponemos la velocidad a 0

        no_r_door:


        cp #9               ;;compruebo que la puerta es azul
        
        jr nz, no_b_door

            ld a, e_nk_b(ix)
            cp #1

            jr nz, no_pasar_b

                ld a, d
                call pintar_suelo

                    push af
                    ld a, #2
                    call play_sound
                    pop af

                jp no_door

            no_pasar_b:

            inc c
            jr nz, no_x4
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vx(ix), a                      ;; ponemos la velocidad a 0
                jr no_b_door
            no_x4:
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vy(ix), a                      ;; ponemos la velocidad a 0

        no_b_door:


        cp #12               ;;compruebo que la puerta es verde
        
        jr nz, no_g_door

            ld a, e_nk_g(ix)
            cp #1

            jr nz, no_pasar_g

                ld a, d
                call pintar_suelo

                    push af
                    ld a, #2
                    call play_sound
                    pop af

                jp no_door

            no_pasar_g:

            inc c
            jr nz, no_x5
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vx(ix), a                      ;; ponemos la velocidad a 0
                jr no_g_door
            no_x5:
                xor a                               ;; A a 0 para cambiar de estado y return
                ld e_vy(ix), a                      ;; ponemos la velocidad a 0

        no_g_door:

        no_door:

ret


comprobar_anillo_player::

    ld d , e_mid_x(ix)                     ;; cargamos en del carry de x
    dec d
    inc d                                  ;; lo decrementamos para saber si es 0 o no
    jr	nz, end_x3                           ;; si es 0 saltamos el codigo de X

    ld d, e_mid_y(ix)                      ;; cargo en d el carry del eje Y
    dec d
    inc d                                  ;; lo decremento para activar el flag z
    jr nz, end_x3                          ;; si esto es cero cambio la velocidad del eje x a 0

    ld a, e_vx(ix)                         ;;selecciono a de movimiento en x
    dec a
    inc a
    jr z, end_x3
    jp m, no_right3
        ;;;;; DERECHAAAAAAA ;;;;;
        ld a, #0x02
        call draw_ring
        jr end_x3                                ;;aqui es innecesario por que hay ret pero si nos movemos a la derecha no podemos movernos a la izquierdo

    no_right3:
        ;;;;; IZQUIERDAAAAAAA ;;;;;
        ld a, #0x00
        call draw_ring
        jr end_x3

    end_x3:

;;comprobamos eje y

    ld d, e_mid_y(ix)                     ;; cargamos en d el primero de los carrys
    dec d    
    inc d                        ;; lo decrementamos para saber si es 0 o no
    jr	nz, end_y3                     ;; si es 0 saltamos el codigo de Y

    ld d, e_mid_x(ix)                      ;; cargo en d el carry de el eje X
    dec d   
    inc d                        ;; lo decremento para activar el flag z
    jr nz, end_y3                ;; si esto es cero cambio la velocidad del eje x a 0

    ld a, e_vy(ix)                  ;;selecciono a de movimiento en x
    dec a
    inc a
    jr z, end_y3
    jp m, no_down2

    ;;;;; ABAJOOOOOOOOOOOO ;;;;;
        ld a, #0x03
        call draw_ring
        jr end_y3

    no_down2:
    ;;;;; ARRIBAAAAAAAAAA ;;;;;
        ld a, #0x01
        call draw_ring
        jr end_y3

    end_y3:

ret

draw_ring::

    call get_adyacent_tile              ;; esto me calcula el tile siguiente al que me voy a mover

    ld d, a
    ld a, (hl)


    call comprobar_anillo


ret

comprobar_anillo::

    cp #30                     ;; compruebo que la llave es amarilla
    jr nz, no_ring

        ld a, d

        ld de, #0xC000                      ;; cargo la posicion de memoria donde empieza la memoria de video
        call get_adyacent_tile_bytes        ;; calculo el tile que quiero pintar en bytes

        call cpct_getScreenPtr_asm          ;; cojo la posicion de memoria de video del enemigo
        
        ex de, hl

        ld hl, #tile_ring              ;; cargo la posicion donde esta el tile que quiero pintar
        call cpct_drawTileAligned4x8_asm    ;; pinto el tile seleccionado


    no_ring:

ret
